#ifndef __PIANO_H_
#define __PIANO_H_

/* Various defines for board logic */
#define B_REC 5
#define B_PLAY 4
#define B_SING  3

#define L_REC 7
#define L_PLAY 6

/* The maximum size (in notes) of a recorded song */
#define MAX_SONG_SIZE 256

/* Working modes for the piano:
 *  - REC:  recording the current song 
 *  - PLAY: play a previously recorded song
 *  - SING: allows the user to sing without recording
 *  */
typedef enum {
        REC,  
        PLAY, 
        SING  
} mode; 

/* The structure that defines a note:
 *  - index:  the oder in the vector song
 *  - delay:  the duration of the note 
 *  */
typedef struct {
        char index;
        unsigned int delay;
} note; 

/* Initialize timer for piano logic */
void initTimer(void);
/* Enable output */
void setPWM(void);
/* Disable output*/
void unsetPWM(void);
/* Set note frequency */
void setNote(int);

#endif
