#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#undef F_CPU
#include <string.h>
#include "piano.h"

mode crt_mode;
int crt_note;
note song[MAX_SONG_SIZE];
int song_size;
int delay;

void initBoard() 
{
	/*output buzzer*/
	DDRD = _BV(PD5);
	TCCR1A |= _BV(WGM10) | _BV(COM1A0);
	TCCR1B |= _BV(WGM13) | _BV(CS12);

	/*keyboard*/
	DDRA &= ~(1 << PA0);
	DDRA &= ~(1 << PA1);
	DDRA &= ~(1 << PA2);
	DDRA &= ~(1 << PA3);
	DDRA &= ~(1 << PA4);
	DDRA &= ~(1 << PA5);
	DDRA &= ~(1 << PA6);
	DDRA &= ~(1 << PA7);

	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);

				
													PORTA |= (1 << PA7);
	crt_mode = SING;
}

int main() 
{
	srand(1);
	TIMSK0 = 0;

	sei();
	
	initBoard();
	initTimer();

	DDRB = 0;
		
	while (1) 
	{
		/* led-uri */
		PORTB = 0xff;
		_delay_ms(500);
	/* Wait for interrupts*/
		int index = -1;
		
		if (delay + 1 < song[crt_note].delay) {
			if (song[crt_note].index == -1) {
				unsetPWM();
			} else {
				setNote(song[crt_note].index);
				setPWM();
			}
			delay++;
		} else {
			delay = 0;
		        crt_note ++;
		        /* Test for the enf of song */
		        if (crt_note >= song_size) {
		        	unsetPWM();
		        	/* Repeat song */
		        	crt_note = 0;
		        	_delay_ms(300);
		        }
		} 
	}     

	return 0;
}
